/* PictPart ver.0.1   (c) 2005 Akkiesoft.  */
/*  Based on viewer.c(part of picture0.)   */
/* stack:30k, malloc:7568k, mmarea:1088k   */

#include <guigui00.h>
#include <stdlib.h>

static int MALLOC_ADDR;
#define malloc(bytes)		(void *) (MALLOC_ADDR -= ((bytes) + 7) & ~7)
#define free(addr)			for (;;); /* freeĂ͍̂ŉiv[v */

#define	AUTO_MALLOC		0
#define SIG_REWIND		1
#define SIG_TMP			16
#define MAX_XSIZ		1600
#define MAX_YSIZ		1200
#define MAX_FSIZ		1024 * 1024

void call_dll0207_48(int *env, int *cmd);
void call_dll0207_48i(int *env, int cmd, ...);

int getsignalw();
static int *sig_ptr, *signalbox0;

void putstr(struct LIB_TEXTBOX *tbox, const char *s, const int i)
{
	lib_putstring1(0x1000, 0, 0, tbox, 0, 0, 0, i, s);
	return;
}

void OsaskMain()
{
	struct LIB_WINDOW *window;
	struct LIB_TEXTBOX *wintitle, *tbox;
	struct LIB_GRAPHBOX *gbox;
	int *env;
	int i, filesize;
	int max[2], info[8];
	char *fp;

	int px, py, sx, sy;

	fp = (char *) (MALLOC_ADDR = lib_readCSd(0x0010));
	lib_init(AUTO_MALLOC);

	sig_ptr = signalbox0 = lib_opensignalbox(256, AUTO_MALLOC, 0, SIG_REWIND);
	window = lib_openwindow1(AUTO_MALLOC, 0x0200, 160, 16, 0x20, 8 - 7);
	wintitle = lib_opentextbox(0x1000, AUTO_MALLOC, 0,  8, 1,  0,  0, window, 0x00c0, 0);
	putstr(wintitle, "PictPart", 8);
	tbox = lib_opentextbox(0x0000, AUTO_MALLOC, 0, 20, 1,  0,  0, window, 0x00c0, 0);

	/* DLL̃[fBO (܂shellxĂȂ̂Ŏ͂ł) */
	lib_initmodulehandle0(0x000c, 0x0210); /* machine-dirɏ */
	lib_steppath0(0, 0x0210, "PICTURE0.BIN", SIG_TMP);
	if (getsignalw() != SIG_TMP) {
		putstr(tbox, "DLL error", 9);
		goto fin;
	}
	lib_mapmodule(0x0000, 0x0210, 0x5, 64 * 1024, fp, 0);
	lib_execcmd0(0x00f0, 0, 0x0200 /* sel */, 0x40fa /* AR */, 64 * 1024 - 1 /* limit */, fp /* ofs */, 0x0008 /* base_sel */, 0);
	fp += 64 * 1024;

	putstr(tbox, "Open file", 9);
	lib_initmodulehandle1(0x0220 /* slot */, 1 /* num */, SIG_TMP);
	if (getsignalw() != SIG_TMP) {
		/* G[LZA̓EBhEN[Y */
		lib_close(0); /* Ƀ^XNI */
		goto fin;
	}
	if ((filesize = lib_readmodulesize(0x0220)) > MAX_FSIZ) {
		putstr(tbox, "Too large file", 14);
		goto fin;
	}

	lib_mapmodule(0x0000 /* opt */, 0x0220 /* slot */, 0x5 /* R-mode */, MAX_FSIZ, fp, 0);
	env = malloc(64 * 1024);
	call_dll0207_48i(env, 0x0001, 0x0000, 0x0002, 0x0000, info, filesize, fp, 0x0000, 0x0000);
	if (info[0] == 0) {
		putstr(tbox, "Not support format", 18);
		goto fin;
	}

again:
	srand(lib_getrandseed());
	sx = rand() % info[2];			// fR[hTCY
	sy = rand() % info[3];
	px = rand() % (info[2] - sx);	// fR[hJnʒu
	py = rand() % (info[3] - sy);

// MAX_?SIZ菬ĂAmax[?]傫ΖӖ
//	if (sx > MAX_XSIZ || sy > MAX_YSIZ)
//		goto again;

	lib_execcmd0(0x0014, 0x10, max, 0x000c, 0x0000);
	if (sx > max[0] || sy > max[1])
		goto again;

	putstr(tbox, "PictPart!!", 10);
	gbox = malloc(sizeof (struct LIB_GRAPHBOX) + MAX_XSIZ * MAX_YSIZ * 4);
	call_dll0207_48i(env, 0x0005, 0x0000, info[0], sx, sy, px, py, filesize, fp, 0x0004, ((char *) gbox) + 64, 0, 0x0000);
	if (env[0]) {
		putstr(tbox, "Decode error", 12);
		goto fin;
	}

	lib_closewindow(0, window);
	getsignalw();
	i = sx;
	if (i < 160)
		i = 160;
	lib_openwindow_nm(window, 0x0200, i, sy);
	lib_opentextbox_nm(0x1000, wintitle, 0,  8, 1,  0,  0, window, 0x00c0, 0);
	putstr(wintitle, "PictPart", 8);
	lib_opengraphbox_nm(0x1001, gbox, 4, 0, sx, sy, 0, 0, window);
fin:
	for (;;)
		getsignalw();
}

int getsignalw()
{
    int signal;
    lib_waitsignal(0x0001, 0, 0);
    if (*sig_ptr == SIG_REWIND) {
        lib_waitsignal(0x0000, *(sig_ptr + 1), 0);
        sig_ptr = signalbox0;
    }
    signal = *sig_ptr;
    if (signal != 0) {
        sig_ptr++;
        lib_waitsignal(0x0000, 1, 0);
    }
    return signal;
}
